/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#if !defined(AFX_GRPBTN3_H__7165D65A_2078_412B_A61A_2220E2D8F850__INCLUDED_)
#define AFX_GRPBTN3_H__7165D65A_2078_412B_A61A_2220E2D8F850__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GrpBtn3.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CGrpBtn window

#define GBS_PUSH 0
#define GBS_CHECK 1
#define GBN_CLICKED 0

enum eState { GB_PLAY, GB_PAUSE, GB_PLAY_OVER, GB_PAUSE_OVER };

class CGrpBtn : public CWnd
{
// Construction
public:
	CGrpBtn();

	CBitmap Bitmap[4];
	eState State;
	eState CheckState;

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGrpBtn)
	//}}AFX_VIRTUAL

// Implementation
public:
	eState GetState();
	void SetState(eState State);
	void ChangeState(eState State);
	BOOL IsPtOnMe(CPoint point);
	void DrawBitmap(CDC *pDC,int x, int y, CBitmap *pBit);
	void DeleteAllBitmap();
	void SetImage(WORD Play, WORD Pause, WORD PlayOver, WORD PauseOver);
	virtual ~CGrpBtn();

	// Generated message map functions
protected:
	//{{AFX_MSG(CGrpBtn)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GRPBTN3_H__7165D65A_2078_412B_A61A_2220E2D8F850__INCLUDED_)
