/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#include "stdafx.h"

#ifdef _WIN32_WCE
#include "..\..\M3RMobile\ChildView.h"
#elif _ACTIVEX
#include "..\..\M3RacX\M3RacXView.h"
#else
#include "..\ChildView.h"
#endif

#include "..\..\src\libLASeR\Datatypes.h"

#include <cmath>

/*#include <MMSystem.h>*/


void CChildView::DrawAnimateTransform(CLASeR *pLASeR)
{
}

void CChildView::PrepareAnimateTransform(CLASeR *pLASeR)
{
	lsrErr err = LASeRNoErr;

	/************************************************************************/
	// get attributes
	UINT8			uAttrType		= pLASeR->GetUINT8Attr(ATTR_ATTRIBUTENAME, &err);
	ErrorMessage(err);

	vector<tstring>	astrBegin		= pLASeR->GetStrListAttr(ATTR_BEGIN, &err);
	ErrorMessage(err);
	float			fDur			= pLASeR->GetFloatAttr(ATTR_DUR, &err);
	ErrorMessage(err);
	vector<tstring>	astrTo			= pLASeR->GetStrListAttr(ATTR_TO, &err);
	ErrorMessage(err);

	UINT8			uFill			= pLASeR->GetUINT8Attr(ATTR_FILL, &err);
	ErrorMessage(err);
	/************************************************************************/

	int nTime = 0;

	for (vector<tstring>::iterator i = astrBegin.begin(); i < astrBegin.end(); ++i)
	{
		nTime = (int)ReadTimesType(i->c_str(), &err);
		ErrorMessage(err);

		if (nTime != -1)
		{
#ifdef _ACTIVEX
			HWND hWnd = this->GetSafeHwnd();

			::SetTimer(hWnd, 1, nTime, NULL);
#else
			SetTimer(m_uTimerIndex, nTime, NULL);
#endif // _ACTIVEX

			m_apTimer.push_back(pLASeR);

			++m_uTimerIndex;
		}
	}
}

void CChildView::TraceEventanmate(const LONG x, const LONG y, CLASeR *pLASeR)
{
	lsrErr err = LASeRNoErr;

	vector<tstring> astrBegin	= pLASeR->GetStrListAttr(ATTR_BEGIN, &err);
	ErrorMessage(err);
	
	UINT8 uFill		= pLASeR->GetUINT8Attr(ATTR_FILL, &err);
	ErrorMessage(err);

	float fdur      = pLASeR->GetFloatAttr(ATTR_DUR, &err);
	ErrorMessage(err);

	tstring strobserver = astrBegin[0];
	CLASeR *pObserver;

	UINT8 uSelected, uVisibility;
	uSelected = uVisibility = 0;

	if (astrBegin[0].find('.') > 0 && astrBegin[0].find('.') < 100)
	{
		strobserver.erase(strobserver.find('.'));

		pObserver = SearchLASeRElementUsingID(strobserver);

		uSelected = ConfirmEventRegion(pObserver, x, y);

		uVisibility = pObserver->GetUINT8Attr(ATTR_VISIBILITY, &err);
	}

	if (uSelected && !uVisibility)
	{
		for (int i=1; i<fdur; i=i+100)
		{
			m_apTimer.push_back(pLASeR);
			SetTimer(m_uTimerIndex, i, NULL);
			++m_uTimerIndex;
		}
	}
}