/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#include "stdafx.h"

#ifdef _WIN32_WCE
#include "..\..\M3RMobile\ChildView.h"
#elif _ACTIVEX
#include "..\..\M3RacX\M3RacXView.h"
#else
#include "..\ChildView.h"
#endif

#include <fstream>

#include <afxinet.h>
#include <afxsock.h>
#include <direct.h>


void CChildView::PrepareListener(CLASeR *pLASeR)
{
	lsrErr err = LASeRNoErr;

	UINT8 kindofevent = pLASeR->GetUINT8Attr(ATTR_EVENT, &err);

	if (kindofevent == 37) //event == xmlUpdate
	{
		tstring strObserver = pLASeR->GetStrAttr(ATTR_OBSERVER, &err);
		ErrorMessage(err);

		strObserver.erase(0, strObserver.find('#')+1);

		CLASeR *pObserver = SearchLASeRElementUsingID(strObserver);
		ErrorMessage(err);

		tstring strHREF = pObserver->GetStrAttr(ATTR_XLINK_HREF, &err);
		ErrorMessage(err);

		// distribute local or remote
		tstring strLocalorRemote = strHREF;
		tstring strFileName = strHREF;
		strLocalorRemote.erase(4);
		if (strLocalorRemote == _T("http"))
		{        //remote
			tstring strDownFileName = strHREF;
			tstring strHREFaddress = strHREF;
			tstring strHREFfolder  = strHREF;

			strDownFileName.erase(strDownFileName.find('#'));

			strHREFaddress.erase(0, strHREFaddress.find('/') + 2);
			strHREFaddress.erase(strHREFaddress.find('/'));

			strHREFfolder.erase(strHREFfolder.find('#'));
			strHREFfolder.erase(0, strHREFfolder.find('/') + 1);
			strHREFfolder.erase(0, strHREFfolder.find('/') + 1);
			strHREFfolder.erase(0, strHREFfolder.find('/') + 1);
			
			CInternetSession m_Session		= NULL;
			CFtpConnection *m_pConnection	= NULL;
			CFtpFileFind *m_pFileFind		= NULL;
			CString m_strRemoteDirText		= NULL;

			if (!AfxSocketInit())
			{
				AfxMessageBox(_T(" ʱȭ "));
			}

			m_pConnection = m_Session.GetFtpConnection(strHREFaddress.c_str());

			if (strHREFfolder.find('/') > 0 && strHREFfolder.find('/') <100)
			{
				tstring strfolder = strHREFfolder;
				strfolder.erase(strfolder.rfind('/'));
				strHREFfolder.erase(0, strHREFfolder.rfind('/')+1);
				m_pConnection->SetCurrentDirectory(strfolder.c_str());
			}
			m_pConnection->GetCurrentDirectory(m_strRemoteDirText);

			if(m_pFileFind) 
				delete m_pFileFind;

			// FTP  ϸ 
			m_pFileFind = new CFtpFileFind(m_pConnection);

			m_pFileFind->FindFile(strHREFfolder.c_str());
			m_pFileFind->FindNextFile();
			
			CTime ct;
			m_pFileFind->GetLastWriteTime(ct);

			m_Time = ct;

			if (m_pConnection)
			{
				m_pConnection->Close();
				delete m_pConnection;
				m_pConnection = NULL;
			}
			if (m_pFileFind)
			{
				delete m_pFileFind;
			}
		}
		else
		{        //local
			tstring strLocalPath = strHREF;
			strLocalPath.erase(strLocalPath.find('#'));
			
			HANDLE hFile = CreateFile(strLocalPath.c_str(), GENERIC_READ, 0, 0, OPEN_ALWAYS,
				FILE_ATTRIBUTE_NORMAL, 0);

			FILETIME ftLastWriteTime;
			SYSTEMTIME stLastWriteTimeUTC, stLastWriteTimeLocal;
			m_uslastmilliseconds = 0;

			GetFileTime(hFile, NULL, NULL, &ftLastWriteTime);
			FileTimeToSystemTime(&ftLastWriteTime, &stLastWriteTimeUTC);
			SystemTimeToTzSpecificLocalTime(NULL, &stLastWriteTimeUTC, &stLastWriteTimeLocal);
			m_uslastmilliseconds = stLastWriteTimeLocal.wMilliseconds;
			CloseHandle(hFile);
		}
		//// ۾
		//CInternetSession m_Session		= NULL;
		//CFtpConnection *m_pConnection	= NULL;
		//CFtpFileFind *m_pFileFind		= NULL;
		//CString m_strRemoteDirText		= NULL;

		//if (!AfxSocketInit())
		//{
		//	AfxMessageBox(_T(" ʱȭ "));
		//}

		//m_pConnection = m_Session.GetFtpConnection(_T("intmedia.khu.ac.kr"));

		//m_pConnection->GetCurrentDirectory(m_strRemoteDirText);

		//if(m_pFileFind) 
		//	delete m_pFileFind;

		//// FTP  ϸ 
		//m_pFileFind = new CFtpFileFind(m_pConnection);

		//m_pFileFind->FindFile(strFileName.c_str());

		//CTime ct;
		//m_pFileFind->GetLastAccessTime(ct);
		////

		/*
		strFileName.erase(strHREF.find('#'));
		strPath.erase(0, strHREF.find('#') + 5);

		HRESULT hr = URLDownloadToFile (NULL,strFileName.c_str(), _T("c:\\testxmlupdate.xml"), 0, NULL);

		ifstream	file("c:\\testxmlupdate.xml", ios::in|ios::binary);

		UINT		uFileSize		= 0;
		char		*szFileData		= NULL;
		wchar_t		*wszFileData	= NULL;

		// move to file's end
		file.seekg(-1, ios_base::end);

		// get file size
		// 2 : for null
		uFileSize = (UINT)(file.tellg()) + 2;

		szFileData = new char[uFileSize];


		memset(szFileData, 0, uFileSize);

		// move to file's start point to read correctly
		file.seekg(0, ios_base::beg);
		file.read(szFileData, uFileSize);
		file.close();
*/
		/************************************************************************/
		//UINT8 bUnicode = 0;

		//if (((szFileData[0] == 0xFF) && (szFileData[1] == 0xFE))
		//	|| ((szFileData[0] == 0xFE) && (szFileData[1] == 0xFF)))
		//	bUnicode = 1;

		//if (bUnicode)
		//{
		//	/* skip */
		//}

		//else
		//{
		//	// char -> wchar_t
		//	wszFileData = new wchar_t[uFileSize];

		//	memset(wszFileData, 0, sizeof(wszFileData));

		//	MultiByteToWideChar(CP_ACP, 0, szFileData, uFileSize, wszFileData, uFileSize);
		//}

		//XNode xml;
		//xml.Load(wszFileData);

		//delete [] szFileData;
		//szFileData = NULL;

		//delete [] wszFileData;
		//wszFileData = NULL;

		//LPXNode found = NULL;

		//tstring strelementname = strPath;

		//strelementname.erase(0, strPath.find(':')+1);
		//strelementname.erase(strelementname.find('/'));

		//found = xml.Find(strelementname.c_str());

		//strxmlupdatevalue = found->value;

		for (int i = 1; i < 1000; i++)
		{
			int nTime = i * 1000;

			m_apTimer.push_back(pLASeR);
			
			SetTimer(m_uTimerIndex, nTime, NULL);

			++m_uTimerIndex;			
		}
	}

	m_apListener.push_back(pLASeR);
}

void CChildView::TraceEventListener(const LONG x, const LONG y)
{
	lsrErr err = LASeRNoErr;

	vector<CLASeR *>::iterator i;

	UINT8 uSelected, uNumOfChildren;
	uSelected = uNumOfChildren = 0;

	for (i = m_apListener.begin(); i < m_apListener.end(); ++i)
	{
		tstring	strObserver	= (*i)->GetStrAttr(ATTR_OBSERVER, &err);
		ErrorMessage(err);

		CLASeR	*pObserver	= SearchLASeRElementUsingID(strObserver);

		uSelected = ConfirmEventRegion(pObserver, x, y);

		if (uSelected) break;
	}

	if (uSelected)
	{
		CLSRConditional *pHandler = SearchConditional((*i)->GetStrAttr(ATTR_HANDLER, &err));
		DrawConditional(pHandler);
	}
}