/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#include "stdafx.h"

#ifdef _WIN32_WCE
#include "..\..\M3RMobile\ChildView.h"
#elif _ACTIVEX
#include "..\..\M3RacX\M3RacXView.h"
#else
#include "..\ChildView.h"
#endif

#include "..\..\src\libLASeR\Datatypes.h"

#include <cmath>

/*#include <MMSystem.h>*/


void CChildView::DrawSet(CLASeR *pLASeR)
{
}

void CChildView::PrepareSet(CLASeR *pLASeR)
{
	lsrErr err = LASeRNoErr;

	m_apSet.push_back(pLASeR);
}

void CChildView::TraceEventSet(const LONG x, const LONG y)
{
	lsrErr err = LASeRNoErr;

	vector<CLASeR *>::iterator i;
	CLASeR *pObserver;

	UINT8 uSelected, uVisibility;
	uSelected = uVisibility = 0;

	/************************/
	UINT8			uAttrType;

	vector<tstring>	astrBegin;
	vector<tstring>	astrTo;

	UINT8			uFill;
	/************************/
	
	for (i = m_apSet.begin(); i < m_apSet.end(); ++i)
	{
		/************************************************************************/
		// get attributes
		uAttrType	= (*i)->GetUINT8Attr(ATTR_ATTRIBUTENAME, &err);
		ErrorMessage(err);

		astrBegin	= (*i)->GetStrListAttr(ATTR_BEGIN, &err);
		ErrorMessage(err);
		astrTo		= (*i)->GetStrListAttr(ATTR_TO, &err);
		ErrorMessage(err);

		uFill		= (*i)->GetUINT8Attr(ATTR_FILL, &err);
		ErrorMessage(err);
		/************************************************************************/

		tstring strobserver = astrBegin[0];

		if (astrBegin[0].find('.') > 0 && astrBegin[0].find('.') < 100)
		{
			strobserver.erase(strobserver.find('.'));

			pObserver = SearchLASeRElementUsingID(strobserver);

			uSelected = ConfirmEventRegion(pObserver, x, y);

			uVisibility = pObserver->GetUINT8Attr(ATTR_VISIBILITY, &err);
		}
		else
		{
			CLASeR *pPLASeR = (*i)->GetParent();

			uSelected = ConfirmEventRegion(pPLASeR, x, y);

			uVisibility = pPLASeR->GetUINT8Attr(ATTR_VISIBILITY, &err);
		}

		if (uSelected && !uVisibility)
		{
			CLASeR *pPLASeR = (*i)->GetParent();

			pPLASeR->SetAttr(uAttrType, astrTo[0]);

			DrawEachElement(pPLASeR);
			DrawScene();

			Invalidate(TRUE);
		}
	}	
}