/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#include "stdafx.h"

#ifdef _WIN32_WCE
#include "..\..\M3RMobile\ChildView.h"
#elif _ACTIVEX
#include "..\..\M3RacX\M3RacXView.h""
#else
#include "..\ChildView.h"

#endif

#include <algorithm>
#include <fstream>
#include "XMLite.h"


//pmsi
tstring	CChildView::GettrefContent(CLASeR *pLASeR)
{
	lsrErr err = LASeRNoErr;

	tstring strTextContent = _T("");

	CLASeR *pChildren = pLASeR->GetChildren(0);

	if (pChildren->GetElementType() == SVG_tref)
	{
		tstring strHREF = pChildren->GetStrAttr(ATTR_XLINK_HREF, &err);

		tstring strFileName = strHREF;
		tstring strPath = strHREF;

		if (strHREF.find('#') == NULL)			// inline tref
		{
			strHREF.erase(0, strHREF.find('#')+1);
			CLASeR *pElement = SearchLASeRElementUsingID(strHREF);
			strTextContent = pElement->GetStrAttr(ATTR_TEXTCONTENT, &err);
		}

		else									// outside source
		{
			strFileName.erase(strHREF.find('#'));
			strPath.erase(0, strHREF.find('#') + 5);

			tstring strDownFileName;
			strDownFileName = strFileName;
			strDownFileName.erase(0, strDownFileName.rfind('/') + 1);
			strDownFileName = _T("C:\\") + strDownFileName;

			//if (m_bcontinouwtref == 0)
			//{
				URLDownloadToFile(NULL, strFileName.c_str(), strDownFileName.c_str(), 0, NULL);
				strTextContent = _T("");

			//	m_bcontinouwtref = 1;
			//}

			//if (strTextContent == _T(""))		// ߺ ٿ޴  
			//{
				ifstream	file(strDownFileName.c_str(), ios::in|ios::binary);
				//		ifstream	file(strFileName.c_str(), ios::in|ios::binary);

				UINT		uFileSize		= 0;
				char		*szFileData		= NULL;
				wchar_t		*wszFileData	= NULL;

				// move to file's end
				file.seekg(-1, ios_base::end);

				// get file size
				// 2 : for null
				uFileSize = (UINT)(file.tellg()) + 2;

				szFileData = new char[uFileSize];

				memset(szFileData, 0, uFileSize);

				// move to file's start point to read correctly
				file.seekg(0, ios_base::beg);
				file.read(szFileData, uFileSize);
				file.close();
				DeleteFile(strDownFileName.c_str());

				/************************************************************************/
				UINT8 bUnicode = 0;

				if (((szFileData[0] == 0xFF) && (szFileData[1] == 0xFE))
					|| ((szFileData[0] == 0xFE) && (szFileData[1] == 0xFF)))
					bUnicode = 1;

				if (bUnicode)
				{
					/* skip */
				}

				else
				{
					// char -> wchar_t
					wszFileData = new wchar_t[uFileSize];

					MultiByteToWideChar(CP_ACP, 0, szFileData, uFileSize, wszFileData, uFileSize);
				}

				XNode xml;
				xml.Load(wszFileData);

				delete [] szFileData;
				szFileData = NULL;

				delete [] wszFileData;
				wszFileData = NULL;

				LPXNode found = NULL;

				tstring strelementname = strPath;

				strelementname.erase(0, strPath.find(':') + 1);
				strelementname.erase(strelementname.find('/'));

				found = xml.Find(strelementname.c_str());

				strTextContent = found->value;
			//}
		}
	}

	return strTextContent;
}