#ifndef _LIBMP4_H
#define _LIBMP4_H

#include <vector>
#include <basetsd.h>
#include <windows.h>
using namespace std;


#ifdef _WIN32_WCE
#define GET_PROC_ADDR	GetProcAddressA
#else
#define GET_PROC_ADDR	GetProcAddress
#endif // _WIN32_WCE


typedef unsigned char BYTE;
typedef unsigned int UINT;


typedef INT8	(__cdecl *PROC_OpenMP4File)(void **theMovie, TCHAR *szFileName);
typedef INT8	(__cdecl *PROC_OpenBitStream)(void **theMovie, unsigned char *pBits, const UINT uSize);
typedef void	(__cdecl *PROC_CloseMP4Record)();
typedef void	(__cdecl *PROC_RemoveMP4Record)(void *pMP4);

typedef void *	(__cdecl *PROC_GetMP4Record)();
typedef void	(__cdecl *PROC_SetMP4Record)(void *pMP4);
typedef BYTE *	(__cdecl *PROC_GetFileStartPoint)();

typedef UINT	(__cdecl *PROC_GetUINT)();
typedef UINT8	(__cdecl *PROC_GetFlag)();
typedef UINT8	(__cdecl *PROC_GetUINT8)();
typedef UINT64	(__cdecl *PROC_GetUINT64)();
typedef float	(__cdecl *PROC_GetFloat)();
typedef UINT *	(__cdecl *PROC_GetLPUINT)();
typedef char *	(__cdecl *PROC_GetLPSTR)();

typedef void	(__cdecl *PROC_GetCompatibleBrands)(vector<UINT> &pBrands);

typedef UINT	(__cdecl *PROC_GetUINTInTrack)(const UINT uTrackIndex);
typedef UINT8	(__cdecl *PROC_GetFlagInTrack)(const UINT uTrackIndex);
typedef UINT8	(__cdecl *PROC_GetUINT8InTrack)(const UINT uTrackIndex);
typedef UINT64	(__cdecl *PROC_GetUINT64InTrack)(const UINT uTrackIndex);
typedef int		(__cdecl *PROC_GetIntInTrack)(const UINT uTrackIndex);
typedef float	(__cdecl *PROC_GetFloatInTrack)(const UINT uTrackIndex);
typedef UINT *	(__cdecl *PROC_GetLPUINTInTrack)(const UINT uTrackIndex);
typedef char *	(__cdecl *PROC_GetLPSTRInTrack)(const UINT uTrackIndex);

typedef UINT	(__cdecl *PROC_GetUINTInEntry)(const UINT uTrackIndex, const UINT uEntryIndex);
typedef UINT8	(__cdecl *PROC_GetFlagInEntry)(const UINT uTrackIndex, const UINT uEntryIndex);
typedef UINT8	(__cdecl *PROC_GetUINT8InEntry)(const UINT uTrackIndex, const UINT uEntryIndex);
typedef UINT64	(__cdecl *PROC_GetUINT64InEntry)(const UINT uTrackIndex, const UINT uEntryIndex);
typedef char *	(__cdecl *PROC_GetLPSTRInEntry)(const UINT uTrackIndex, const UINT uEntryIndex);
typedef BYTE *	(__cdecl *PROC_GetLPBYTEInEntry)(const UINT uTrackIndex, const UINT uEntryIndex);

typedef UINT	(__cdecl *PROC_GetUINTInArray)(const UINT uTrackIndex, const UINT uEntryIndex, const UINT8 i);
typedef BYTE *	(__cdecl *PROC_GetLPBYTEInArray)(const UINT uTrackIndex, const UINT uEntryIndex, const UINT8 i);


class CLibMP4Api
{
protected:
	HMODULE m_hInst;

	PROC_OpenMP4File			m_pfnOpenMP4File;
	PROC_OpenBitStream			m_pfnOpenBitStream;
	PROC_CloseMP4Record			m_pfnCloseMP4Record;
	PROC_RemoveMP4Record		m_pfnRemoveMP4Record;

	PROC_GetMP4Record			m_pfnGetMP4Record;
	PROC_SetMP4Record			m_pfnSetMP4Record;
	PROC_GetFileStartPoint		m_pfnGetFileStartPoint;

	PROC_GetUINT				m_pfnGetMajorBrand;
	PROC_GetUINT				m_pfnGetMinorVersion;
	PROC_GetCompatibleBrands	m_pfnGetCompatibleBrands;

	PROC_GetUINT64				m_pfnGetMovieCreationTime;
	PROC_GetUINT64				m_pfnGetMovieModificationTime;
	PROC_GetUINT				m_pfnGetMovieTimeScale;
	PROC_GetUINT64				m_pfnGetMovieDuration;
	PROC_GetFloat				m_pfnGetRate;
	PROC_GetFloat				m_pfnGetMovieVolume;
	PROC_GetLPUINT				m_pfnGetMovieMatrix;
	PROC_GetUINT				m_pfnGetNextTrackID;

	PROC_GetFlag				m_pfnHasIODS;
	PROC_GetUINT				m_pfnGetTrackCount;
	PROC_GetUINTInTrack			m_pfnTrackID2Index;

	PROC_GetUINT				m_pfnGetObjectDescriptorID;
	PROC_GetUINT8				m_pfnGetURLFlag;
	PROC_GetUINT8				m_pfnGetInlineProfileLevelFlag;
	PROC_GetUINT8				m_pfnGetIODURLLength;
	PROC_GetLPSTR				m_pfnGetIODURLString;
	PROC_GetUINT8				m_pfnGetODProfileLevel;
	PROC_GetUINT8				m_pfnGetSceneProfileLevel;
	PROC_GetUINT8				m_pfnGetAudioProfileLevel;
	PROC_GetUINT8				m_pfnGetVisualProfileLevel;
	PROC_GetUINT8				m_pfnGetGraphicsProfileLevel;
	PROC_GetUINT8				m_pfnGetESDescSize;

	PROC_GetUINT64InTrack		m_pfnGetTrackCreationTime;
	PROC_GetUINT64InTrack		m_pfnGetTrackModificationTime;
	PROC_GetUINTInTrack			m_pfnGetTrackID;
	PROC_GetUINT64InTrack		m_pfnGetTrackDuration;
	PROC_GetIntInTrack			m_pfnGetLayer;
	PROC_GetIntInTrack			m_pfnGetAlternateGroup;
	PROC_GetFloatInTrack		m_pfnGetTrackVolume;
	PROC_GetLPUINTInTrack		m_pfnGetTrackMatrix;
	PROC_GetUINTInTrack			m_pfnGetWidth;
	PROC_GetUINTInTrack			m_pfnGetHeight;

	PROC_GetFlagInTrack			m_pfnHasTREF;

	PROC_GetUINT64InTrack		m_pfnGetMediaCreationTime;
	PROC_GetUINT64InTrack		m_pfnGetMediaModificationTime;
	PROC_GetUINTInTrack			m_pfnGetMediaTimeScale;
	PROC_GetUINT64InTrack		m_pfnGetMediaDuration;
	PROC_GetUINTInTrack			m_pfnGetLanguage;

	PROC_GetUINTInTrack			m_pfnGetHandlerType;
	PROC_GetLPSTRInTrack		m_pfnGetHandlerName;

	PROC_GetUINTInTrack			m_pfnGetMediaHeaderType;

	PROC_GetUINTInTrack			m_pfnGetMP4GraphicsMode;
	PROC_GetLPUINTInTrack		m_pfnGetOpColor;

	PROC_GetFloatInTrack		m_pfnGetBalance;

	PROC_GetUINTInTrack			m_pfnGetMaxPDUSize;
	PROC_GetUINTInTrack			m_pfnGetAvgPDUSize;
	PROC_GetUINTInTrack			m_pfnGetMaxHintBitrate;
	PROC_GetUINTInTrack			m_pfnGetAvgHintBitrate;

	PROC_GetUINTInTrack			m_pfnGetDREFCount;
	PROC_GetUINTInEntry			m_pfnGetDREFType;

	PROC_GetLPSTRInEntry		m_pfnGetDataName;
	PROC_GetLPSTRInEntry		m_pfnGetLocation;

	PROC_GetFlagInTrack			m_pfnHasCTTS;
	PROC_GetFlagInTrack			m_pfnHasSTSS;
	PROC_GetFlagInTrack			m_pfnHasSVMI;

	PROC_GetUINTInTrack			m_pfnGetSampleDescCount;
	PROC_GetUINTInEntry			m_pfnGetSampleDescType;

	PROC_GetLPBYTEInEntry		m_pfnGetDecoderConfigOffset;
	PROC_GetUINTInEntry			m_pfnGetDecoderConfigSize;

	PROC_GetUINTInEntry			m_pfnGetDataReferenceIndex;

	PROC_GetFlagInEntry			m_pfnHasBTRT;
	PROC_GetFlagInEntry			m_pfnHasM4DS;

	PROC_GetUINTInEntry			m_pfnGetVisualWidth;
	PROC_GetUINTInEntry			m_pfnGetVisualHeight;
	PROC_GetUINTInEntry			m_pfnGetHorizResolution;
	PROC_GetUINTInEntry			m_pfnGetVertResolution;
	PROC_GetUINTInEntry			m_pfnGetFrameCount;
	PROC_GetLPSTRInEntry		m_pfnGetCompressorName;
	PROC_GetUINTInEntry			m_pfnGetDepth;

	PROC_GetUINTInEntry			m_pfnGetChannelCount;
	PROC_GetUINTInEntry			m_pfnGetAudioSampleSize;
	PROC_GetUINTInEntry			m_pfnGetSampleRate;

	PROC_GetLPBYTEInEntry		m_pfnGetData;

	PROC_GetUINTInEntry			m_pfnGetESID;
	PROC_GetUINT8InEntry		m_pfnGetStreamDependenceFlag;
	PROC_GetUINT8InEntry		m_pfnGetESURLFlag;
	PROC_GetUINT8InEntry		m_pfnGetOCRStreamFlag;
	PROC_GetUINT8InEntry		m_pfnGetStreamPriority;
	PROC_GetUINTInEntry			m_pfnGetDependsOnESID;
	PROC_GetUINT8InEntry		m_pfnGetESURLLength;
	PROC_GetLPSTRInEntry		m_pfnGetESURLString;
	PROC_GetUINTInEntry			m_pfnGetOCRESID;

	PROC_GetUINT8InEntry		m_pfnGetESObjectType;
	PROC_GetUINT8InEntry		m_pfnGetStreamType;
	PROC_GetUINT8InEntry		m_pfnGetUpStream;

	PROC_GetUINT8InEntry		m_pfnGetConfigurationVersion;
	PROC_GetUINT8InEntry		m_pfnGetAVCProfileIndication;
	PROC_GetUINT8InEntry		m_pfnGetProfileCompatibility;
	PROC_GetUINT8InEntry		m_pfnGetAVCLevelIndication;
	PROC_GetUINT8InEntry		m_pfnGetLength;
	PROC_GetUINT8InEntry		m_pfnGetNumOfSPS;
	PROC_GetUINTInArray			m_pfnGetSPSLength;
	PROC_GetLPBYTEInArray		m_pfnGetSPSNALUnit;
	PROC_GetUINT8InEntry		m_pfnGetNumOfPPS;
	PROC_GetUINTInArray			m_pfnGetPPSLength;
	PROC_GetLPBYTEInArray		m_pfnGetPPSNALUnit;

	PROC_GetUINTInEntry			m_pfnGetBufferSizeDB;
	PROC_GetUINTInEntry			m_pfnGetMaxBitrate;
	PROC_GetUINTInEntry			m_pfnGetAvgBitrate;
	PROC_GetLPBYTEInEntry		m_pfnGetDecSpecificInfoData;

	PROC_GetUINTInTrack			m_pfnGetSTTSCount;
	PROC_GetUINTInEntry			m_pfnGetSTTSSampleCount;
	PROC_GetUINTInEntry			m_pfnGetSampleDelta;
	PROC_GetUINTInEntry			m_pfnGetExactSampleDelta;

	PROC_GetUINTInTrack			m_pfnGetCTTSCount;
	PROC_GetUINTInEntry			m_pfnGetCTTSSampleCount;
	PROC_GetUINTInEntry			m_pfnGetSampleOffset;
	PROC_GetUINTInEntry			m_pfnGetExactSampleOffset;

	PROC_GetUINTInTrack			m_pfnGetSTSSCount;
	PROC_GetUINTInEntry			m_pfnGetSampleNumber;
	PROC_GetUINT8InEntry		m_pfnCheckSyncSample;

	PROC_GetUINTInTrack			m_pfnGetSTSCCount;
	PROC_GetUINTInEntry			m_pfnGetFirstChunk;
	PROC_GetUINTInEntry			m_pfnGetSamplesPerChunk;
	PROC_GetUINTInEntry			m_pfnGetSampleDescIndex;
	PROC_GetUINTInEntry			m_pfnGetIndexUsingRealChunk;
	PROC_GetUINTInEntry			m_pfnCheckSample2Chunk;

	PROC_GetUINT8InTrack		m_pfnGetSampleSizeBoxType;
	PROC_GetUINTInTrack			m_pfnGetSampleSize;
	PROC_GetUINT8InTrack		m_pfnGetFieldSize;
	PROC_GetUINTInTrack			m_pfnGetSampleCount;
	PROC_GetUINTInEntry			m_pfnGetEntrySize;

	PROC_GetUINT8InTrack		m_pfnGetChunkOffsetBoxType;
	PROC_GetUINTInTrack			m_pfnGetSTCOCount;
	PROC_GetUINT64InEntry		m_pfnGetChunkOffset;

	PROC_GetUINT8InTrack		m_pfnGetStereoCompositionType;
	PROC_GetFlagInTrack			m_pfnGetIsLeftFirst;
	PROC_GetUINTInTrack			m_pfnGetStereoMonoChangeCount;
	PROC_GetUINTInEntry			m_pfnGetSVMISampleCount;
	PROC_GetFlagInEntry			m_pfnGetStereoFlag;

public:
	UINT8						bFirstTime;					// first time of call
	UINT8						uStateOfStream;
	UINT8						uStateOfAU;

	void						*pPacket;					// output packet struct
	// decoder config descriptor
	vector<BYTE>				abySimpleDecoderConfigDescriptor;

	BYTE						*pFileStartPoint;
	UINT						uTrackCount;

	UINT						uTrackIndex;
	UINT						uChunkIndex;
	UINT						uSampleEntryIndex;
	UINT						uSampleIndex;

	vector<UINT>				auSampleCount;

	vector<UINT>				auCurChunkIndex;
	vector<UINT>				auSamplesInCurChunk;

	vector<UINT>				auCurSampleSize;
	vector<BYTE *>				auCurSampleOffset;
	vector<UINT>				auCurSampleIndex;
	vector<float>				afPassed;

	vector<UINT>				auDescChangedChunk;
	vector<UINT>				auOldSampleEntryIndex;
	vector<UINT>				auCTS;
	vector<UINT>				auDTS;

	BYTE						*pOffset;
	UINT						uPayloadSize;

public:
	CLibMP4Api()
	{
		// Loading libmp4.dll
		try
		{
#ifdef _WIN32_WCE
			m_hInst = LoadLibrary(_T("libmp4CE.dll"));
			if (!m_hInst)						throw(_T("Unable to load libmp4CE.dll"));
#else
			m_hInst = LoadLibrary(_T("libmp4.dll"));
			if (!m_hInst)						throw(_T("Unable to load libmp4.dll"));
#endif

			// Get DLL functions
			m_pfnOpenMP4File = (PROC_OpenMP4File)GET_PROC_ADDR(m_hInst, "OpenMP4File");
			if (!m_pfnOpenMP4File)				throw(_T("Don't find 'OpenMP4File' function"));

			m_pfnOpenBitStream = (PROC_OpenBitStream)GET_PROC_ADDR(m_hInst, "OpenBitStream");
			if (!m_pfnOpenBitStream)			throw(_T("Don't find 'OpenBitStream' function"));

			m_pfnCloseMP4Record = (PROC_CloseMP4Record)GET_PROC_ADDR(m_hInst, "CloseMP4Record");
			if (!m_pfnCloseMP4Record)			throw(_T("Don't find 'CloseMP4Record' function"));

			m_pfnRemoveMP4Record = (PROC_RemoveMP4Record)GET_PROC_ADDR(m_hInst, "RemoveMP4Record");
			if (!m_pfnRemoveMP4Record)			throw(_T("Don't find 'RemoveMP4Record' function"));

			m_pfnGetMP4Record = (PROC_GetMP4Record)GET_PROC_ADDR(m_hInst, "GetMP4Record");
			if (!m_pfnGetMP4Record)				throw(_T("Don't find 'GetMP4Record' function"));

			m_pfnSetMP4Record = (PROC_SetMP4Record)GET_PROC_ADDR(m_hInst, "SetMP4Record");
			if (!m_pfnSetMP4Record)				throw(_T("Don't find 'SetMP4Record' function"));

			m_pfnGetFileStartPoint = (PROC_GetFileStartPoint)GET_PROC_ADDR(m_hInst, "GetFileStartPoint");
			if (!m_pfnGetFileStartPoint)		throw(_T("Don't find 'GetFileStartPoint' function"));

			/************************************************************************/
			m_pfnGetMajorBrand = (PROC_GetUINT)GET_PROC_ADDR(m_hInst, "GetMajorBrand");
			if (!m_pfnGetMajorBrand)			throw(_T("Don't find 'GetMajorBrand' function"));

			m_pfnGetMinorVersion = (PROC_GetUINT)GET_PROC_ADDR(m_hInst, "GetMinorVersion");
			if (!m_pfnGetMinorVersion)			throw(_T("Don't find 'GetMinorVersion' function"));

			m_pfnGetCompatibleBrands = (PROC_GetCompatibleBrands)GET_PROC_ADDR(m_hInst, "GetCompatibleBrands");
			if (!m_pfnGetCompatibleBrands)		throw(_T("Don't find 'GetCompatibleBrands' function"));

			/************************************************************************/
			m_pfnGetMovieCreationTime = (PROC_GetUINT64)GET_PROC_ADDR(m_hInst, "GetMovieCreationTime");
			if (!m_pfnGetMovieCreationTime)		throw(_T("Don't find 'GetMovieCreationTime' function"));

			m_pfnGetMovieModificationTime = (PROC_GetUINT64)GET_PROC_ADDR(m_hInst, "GetMovieModificationTime");
			if (!m_pfnGetMovieModificationTime)	throw(_T("Don't find 'GetMovieModificationTime' function"));

			m_pfnGetMovieTimeScale = (PROC_GetUINT)GET_PROC_ADDR(m_hInst, "GetMovieTimeScale");
			if (!m_pfnGetMovieTimeScale)		throw(_T("Don't find 'GetMovieTimeScale' function"));

			m_pfnGetMovieDuration = (PROC_GetUINT64)GET_PROC_ADDR(m_hInst, "GetMovieDuration");
			if (!m_pfnGetMovieDuration)			throw(_T("Don't find 'GetMovieDuration' function"));

			m_pfnGetRate = (PROC_GetFloat)GET_PROC_ADDR(m_hInst, "GetRate");
			if (!m_pfnGetRate)					throw(_T("Don't find 'GetRate' function"));

			m_pfnGetMovieVolume = (PROC_GetFloat)GET_PROC_ADDR(m_hInst, "GetMovieVolume");
			if (!m_pfnGetMovieVolume)			throw(_T("Don't find 'GetVolume' function"));

			m_pfnGetMovieMatrix = (PROC_GetLPUINT)GET_PROC_ADDR(m_hInst, "GetMovieMatrix");
			if (!m_pfnGetMovieMatrix)			throw(_T("Don't find 'GetMovieMatrix' function"));

			m_pfnGetNextTrackID = (PROC_GetUINT)GET_PROC_ADDR(m_hInst, "GetNextTrackID");
			if (!m_pfnGetNextTrackID)			throw(_T("Don't find 'GetNextTrackID' function"));

			m_pfnHasIODS = (PROC_GetFlag)GET_PROC_ADDR(m_hInst, "HasIODS");
			if (!m_pfnHasIODS)					throw(_T("Don't find 'HasIODS' function"));

			m_pfnGetTrackCount = (PROC_GetUINT)GET_PROC_ADDR(m_hInst, "GetTrackCount");
			if (!m_pfnGetTrackCount)			throw(_T("Don't find 'GetTrackCount' function"));

			m_pfnTrackID2Index = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "TrackID2Index");
			if (!m_pfnTrackID2Index)			throw(_T("Don't find 'TrackID2Index' function"));

			m_pfnGetObjectDescriptorID = (PROC_GetUINT)GET_PROC_ADDR(m_hInst, "GetObjectDescriptorID");
			if (!m_pfnGetObjectDescriptorID)	throw(_T("Don't find 'GetObjectDescriptorID' function"));

			m_pfnGetURLFlag = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetURLFlag");
			if (!m_pfnGetURLFlag)				throw(_T("Don't find 'GetURLFlag' function"));

			m_pfnGetInlineProfileLevelFlag = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetInlineProfileLevelFlag");
			if (!m_pfnGetInlineProfileLevelFlag)throw(_T("Don't find 'GetInlineProfileLevelFlag' function"));

			m_pfnGetIODURLLength = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetIODURLLength");
			if (!m_pfnGetIODURLLength)			throw(_T("Don't find 'GetIODURLLength' function"));

			m_pfnGetIODURLString = (PROC_GetLPSTR)GET_PROC_ADDR(m_hInst, "GetIODURLString");
			if (!m_pfnGetIODURLString)			throw(_T("Don't find 'GetIODURLString' function"));

			m_pfnGetODProfileLevel = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetODProfileLevel");
			if (!m_pfnGetODProfileLevel)		throw(_T("Don't find 'GetODProfileLevel' function"));

			m_pfnGetSceneProfileLevel = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetSceneProfileLevel");
			if (!m_pfnGetSceneProfileLevel)		throw(_T("Don't find 'GetSceneProfileLevel' function"));

			m_pfnGetAudioProfileLevel = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetAudioProfileLevel");
			if (!m_pfnGetAudioProfileLevel)		throw(_T("Don't find 'GetAudioProfileLevel' function"));

			m_pfnGetVisualProfileLevel = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetVisualProfileLevel");
			if (!m_pfnGetVisualProfileLevel)	throw(_T("Don't find 'GetVisualProfileLevel' function"));

			m_pfnGetGraphicsProfileLevel = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetGraphicsProfileLevel");
			if (!m_pfnGetGraphicsProfileLevel)	throw(_T("Don't find 'GetGraphicsProfileLevel' function"));

			m_pfnGetESDescSize = (PROC_GetUINT8)GET_PROC_ADDR(m_hInst, "GetESDescSize");
			if (!m_pfnGetESDescSize)			throw(_T("Don't find 'GetESDescSize' function"));

			/************************************************************************/
			m_pfnGetTrackCreationTime = (PROC_GetUINT64InTrack)GET_PROC_ADDR(m_hInst, "GetTrackCreationTime");
			if (!m_pfnGetTrackCreationTime)		throw(_T("Don't find 'GetTrackCreationTime' function"));

			m_pfnGetTrackModificationTime = (PROC_GetUINT64InTrack)GET_PROC_ADDR(m_hInst, "GetTrackModificationTime");
			if (!m_pfnGetTrackModificationTime)	throw(_T("Don't find 'GetTrackModificationTime' function"));

			m_pfnGetTrackID = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetTrackID");
			if (!m_pfnGetTrackID)				throw(_T("Don't find 'GetTrackID' function"));

			m_pfnGetTrackDuration= (PROC_GetUINT64InTrack)GET_PROC_ADDR(m_hInst, "GetTrackDuration");
			if (!m_pfnGetTrackDuration)			throw(_T("Don't find 'GetTrackDuration' function"));

			m_pfnGetLayer = (PROC_GetIntInTrack)GET_PROC_ADDR(m_hInst, "GetLayer");
			if (!m_pfnGetLayer)					throw(_T("Don't find 'GetLayer' function"));

			m_pfnGetAlternateGroup = (PROC_GetIntInTrack)GET_PROC_ADDR(m_hInst, "GetAlternateGroup");
			if (!m_pfnGetAlternateGroup)		throw(_T("Don't find 'GetAlternateGroup' function"));

			m_pfnGetTrackVolume = (PROC_GetFloatInTrack)GET_PROC_ADDR(m_hInst, "GetTrackVolume");
			if (!m_pfnGetTrackVolume)			throw(_T("Don't find 'GetTrackVolume' function"));

			m_pfnGetTrackMatrix = (PROC_GetLPUINTInTrack)GET_PROC_ADDR(m_hInst, "GetTrackMatrix");
			if (!m_pfnGetTrackMatrix)			throw(_T("Don't find 'GetTrackMatrix' function"));

			m_pfnGetWidth = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetWidth");
			if (!m_pfnGetWidth)					throw(_T("Don't find 'GetWidth' function"));

			m_pfnGetHeight = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetHeight");
			if (!m_pfnGetHeight)				throw(_T("Don't find 'GetHeight' function"));

			m_pfnHasTREF = (PROC_GetFlagInTrack)GET_PROC_ADDR(m_hInst, "HasTREF");
			if (!m_pfnHasTREF)					throw(_T("Don't find 'HasTREF' function"));

			m_pfnGetMediaCreationTime = (PROC_GetUINT64InTrack)GET_PROC_ADDR(m_hInst, "GetMediaCreationTime");
			if (!m_pfnGetMediaCreationTime)		throw(_T("Don't find 'GetMediaCreationTime' function"));

			m_pfnGetMediaModificationTime = (PROC_GetUINT64InTrack)GET_PROC_ADDR(m_hInst, "GetMediaModificationTime");
			if (!m_pfnGetMediaModificationTime)	throw(_T("Don't find 'GetMediaModificationTime' function"));

			m_pfnGetMediaTimeScale = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetMediaTimeScale");
			if (!m_pfnGetMediaTimeScale)		throw(_T("Don't find 'GetMediaTimeScale' function"));

			m_pfnGetMediaDuration = (PROC_GetUINT64InTrack)GET_PROC_ADDR(m_hInst, "GetMediaDuration");
			if (!m_pfnGetMediaDuration)			throw(_T("Don't find 'GetMediaDuration' function"));

			m_pfnGetLanguage = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetLanguage");
			if (!m_pfnGetLanguage)				throw(_T("Don't find 'GetLanguage' function"));

			m_pfnGetHandlerType = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetHandlerType");
			if (!m_pfnGetHandlerType)			throw(_T("Don't find 'GetHandlerType' function"));

			m_pfnGetHandlerName = (PROC_GetLPSTRInTrack)GET_PROC_ADDR(m_hInst, "GetHandlerName");
			if (!m_pfnGetHandlerName)			throw(_T("Don't find 'GetHandlerName' function"));

			m_pfnGetMediaHeaderType = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetMediaHeaderType");
			if (!m_pfnGetMediaHeaderType)		throw(_T("Don't find 'HasVideoMediaHeader' function"));

			m_pfnGetMP4GraphicsMode = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetMP4GraphicsMode");
			if (!m_pfnGetMP4GraphicsMode)		throw(_T("Don't find 'GetMP4GraphicsMode' function"));

			m_pfnGetOpColor = (PROC_GetLPUINTInTrack)GET_PROC_ADDR(m_hInst, "GetOpColor");
			if (!m_pfnGetOpColor)				throw(_T("Don't find 'GetOpColor' function"));

			m_pfnGetBalance = (PROC_GetFloatInTrack)GET_PROC_ADDR(m_hInst, "GetBalance");
			if (!m_pfnGetBalance)				throw(_T("Don't find 'GetBalance' function"));

			m_pfnGetMaxPDUSize = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetMaxPDUSize");
			if (!m_pfnGetMaxPDUSize)			throw(_T("Don't find 'GetMaxPDUSize' function"));

			m_pfnGetAvgPDUSize = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetAvgPDUSize");
			if (!m_pfnGetAvgPDUSize)			throw(_T("Don't find 'GetAvgPDUSize' function"));

			m_pfnGetMaxHintBitrate = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetMaxHintBitrate");
			if (!m_pfnGetMaxHintBitrate)		throw(_T("Don't find 'GetMaxHintBitrate' function"));

			m_pfnGetAvgHintBitrate = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetAvgHintBitrate");
			if (!m_pfnGetAvgHintBitrate)		throw(_T("Don't find 'GetAvgHintBitrate' function"));

			m_pfnGetDREFCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetDREFCount");
			if (!m_pfnGetDREFCount)				throw(_T("Don't find 'GetDREFCount' function"));

			m_pfnGetDREFType = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetDREFType");
			if (!m_pfnGetDREFType)				throw(_T("Don't find 'GetDREFType' function"));

			m_pfnGetDataName = (PROC_GetLPSTRInEntry)GET_PROC_ADDR(m_hInst, "GetDataName");
			if (!m_pfnGetDataName)				throw(_T("Don't find 'GetDataName' function"));

			m_pfnGetLocation = (PROC_GetLPSTRInEntry)GET_PROC_ADDR(m_hInst, "GetLocation");
			if (!m_pfnGetLocation)				throw(_T("Don't find 'GetLocation' function"));

			/************************************************************************/
			m_pfnHasCTTS = (PROC_GetFlagInTrack)GET_PROC_ADDR(m_hInst, "HasCTTS");
			if (!m_pfnHasCTTS)					throw(_T("Don't find 'HasCTTS' function"));

			m_pfnHasSTSS = (PROC_GetFlagInTrack)GET_PROC_ADDR(m_hInst, "HasSTSS");
			if (!m_pfnHasSTSS)					throw(_T("Don't find 'HasSTSS' function"));

			m_pfnHasSVMI = (PROC_GetFlagInTrack)GET_PROC_ADDR(m_hInst, "HasSVMI");
			if (!m_pfnHasSVMI)					throw(_T("Don't find 'HasSVMI' function"));

			m_pfnGetSampleDescCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetSampleDescCount");
			if (!m_pfnGetSampleDescCount)		throw(_T("Don't find 'GetSampleDescCount' function"));

			m_pfnGetSampleDescType = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSampleDescType");
			if (!m_pfnGetSampleDescType)		throw(_T("Don't find 'GetSampleDescType' function"));

			m_pfnGetDecoderConfigOffset = (PROC_GetLPBYTEInEntry)GET_PROC_ADDR(m_hInst, "GetDecoderConfigOffset");
			if (!m_pfnGetDecoderConfigOffset)	throw(_T("Don't find 'GetDecoderConfigOffset' function"));

			m_pfnGetDecoderConfigSize = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetDecoderConfigSize");
			if (!m_pfnGetDecoderConfigSize)		throw(_T("Don't find 'GetDecoderConfigSize' function"));

			m_pfnGetDataReferenceIndex = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetDataReferenceIndex");
			if (!m_pfnGetDataReferenceIndex)	throw(_T("Don't find 'GetDataReferenceIndex' function"));

			m_pfnHasBTRT = (PROC_GetFlagInEntry)GET_PROC_ADDR(m_hInst, "HasBTRT");
			if (!m_pfnHasBTRT)					throw(_T("Don't find 'HasBTRT' function"));

			m_pfnHasM4DS = (PROC_GetFlagInEntry)GET_PROC_ADDR(m_hInst, "HasM4DS");
			if (!m_pfnHasM4DS)					throw(_T("Don't find 'HasM4DS' function"));

			m_pfnGetVisualWidth = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetVisualWidth");
			if (!m_pfnGetVisualWidth)			throw(_T("Don't find 'GetVisualWidth' function"));

			m_pfnGetVisualHeight = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetVisualHeight");
			if (!m_pfnGetVisualHeight)			throw(_T("Don't find 'GetVisualHeight' function"));

			m_pfnGetHorizResolution = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetHorizResolution");
			if (!m_pfnGetHorizResolution)		throw(_T("Don't find 'GetHorizResolution' function"));

			m_pfnGetVertResolution = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetVertResolution");
			if (!m_pfnGetVertResolution)		throw(_T("Don't find 'GetVertResolution' function"));

			m_pfnGetFrameCount = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetFrameCount");
			if (!m_pfnGetFrameCount)			throw(_T("Don't find 'GetFrameCount' function"));

			m_pfnGetCompressorName = (PROC_GetLPSTRInEntry)GET_PROC_ADDR(m_hInst, "GetCompressorName");
			if (!m_pfnGetCompressorName)		throw(_T("Don't find 'GetCompressorName' function"));

			m_pfnGetDepth = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetDepth");
			if (!m_pfnGetDepth)					throw(_T("Don't find 'GetDepth' function"));

			m_pfnGetChannelCount = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetChannelCount");
			if (!m_pfnGetChannelCount)			throw(_T("Don't find 'GetChannelCount' function"));

			m_pfnGetAudioSampleSize = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetAudioSampleSize");
			if (!m_pfnGetAudioSampleSize)		throw(_T("Don't find 'GetAudioSampleSize' function"));

			m_pfnGetSampleRate = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSampleRate");
			if (!m_pfnGetSampleRate)			throw(_T("Don't find 'GetSampleRate' function"));

			m_pfnGetData = (PROC_GetLPBYTEInEntry)GET_PROC_ADDR(m_hInst, "GetData");
			if (!m_pfnGetData)					throw(_T("Don't find 'GetData' function"));

			m_pfnGetESID = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetESID");
			if (!m_pfnGetESID)					throw(_T("Don't find 'GetESID' function"));

			m_pfnGetStreamDependenceFlag = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetStreamDependenceFlag");
			if (!m_pfnGetStreamDependenceFlag)	throw(_T("Don't find 'GetStreamDependenceFlag' function"));

			m_pfnGetESURLFlag = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetESURLFlag");
			if (!m_pfnGetESURLFlag)				throw(_T("Don't find 'GetESURLFlag' function"));

			m_pfnGetOCRStreamFlag = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetOCRStreamFlag");
			if (!m_pfnGetOCRStreamFlag)			throw(_T("Don't find 'GetOCRStreamFlag' function"));

			m_pfnGetStreamPriority = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetStreamPriority");
			if (!m_pfnGetStreamPriority)		throw(_T("Don't find 'GetStreamPriority' function"));

			m_pfnGetDependsOnESID = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetDependsOnESID");
			if (!m_pfnGetDependsOnESID)			throw(_T("Don't find 'GetDependsOnESID' function"));

			m_pfnGetESURLLength = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetESURLLength");
			if (!m_pfnGetESURLLength)			throw(_T("Don't find 'GetESURLLength' function"));

			m_pfnGetESURLString = (PROC_GetLPSTRInEntry)GET_PROC_ADDR(m_hInst, "GetESURLString");
			if (!m_pfnGetESURLString)			throw(_T("Don't find 'GetESURLString' function"));

			m_pfnGetOCRESID = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetOCRESID");
			if (!m_pfnGetOCRESID)				throw(_T("Don't find 'GetOCRESID' function"));

			m_pfnGetESObjectType = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetESObjectType");
			if (!m_pfnGetESObjectType)			throw(_T("Don't find 'GetESObjectType' function"));

			m_pfnGetStreamType = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetStreamType");
			if (!m_pfnGetStreamType)			throw(_T("Don't find 'GetStreamType' function"));

			m_pfnGetUpStream = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetUpStream");
			if (!m_pfnGetUpStream)			throw(_T("Don't find 'GetUpStream' function"));

			m_pfnGetConfigurationVersion = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetConfigurationVersion");
			if (!m_pfnGetConfigurationVersion)	throw(_T("Don't find 'GetConfigurationVersion' function"));

			m_pfnGetAVCProfileIndication = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetAVCProfileIndication");	
			if (!m_pfnGetAVCProfileIndication)	throw(_T("Don't find 'GetAVCProfileIndication' function"));

			m_pfnGetProfileCompatibility = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetProfileCompatibility");
			if (!m_pfnGetProfileCompatibility)	throw(_T("Don't find 'GetProfileCompatibility' function"));

			m_pfnGetAVCLevelIndication = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetAVCLevelIndication");
			if (!m_pfnGetAVCLevelIndication)	throw(_T("Don't find 'GetAVCLevelIndication' function"));

			m_pfnGetLength = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetLength");
			if (!m_pfnGetLength)				throw(_T("Don't find 'GetLength' function"));

			m_pfnGetNumOfSPS = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetNumOfSPS");
			if (!m_pfnGetNumOfSPS)				throw(_T("Don't find 'GetNumOfSPS' function"));

			m_pfnGetSPSLength = (PROC_GetUINTInArray)GET_PROC_ADDR(m_hInst, "GetSPSLength");
			if (!m_pfnGetSPSLength)				throw(_T("Don't find 'GetSPSLength' function"));

			m_pfnGetSPSNALUnit = (PROC_GetLPBYTEInArray)GET_PROC_ADDR(m_hInst, "GetSPSNALUnit");
			if (!m_pfnGetSPSNALUnit)			throw(_T("Don't find 'GetSPSNALUnit' function"));

			m_pfnGetNumOfPPS = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "GetNumOfPPS");
			if (!m_pfnGetNumOfPPS)				throw(_T("Don't find 'GetNumOfPPS' function"));

			m_pfnGetPPSLength = (PROC_GetUINTInArray)GET_PROC_ADDR(m_hInst, "GetPPSLength");
			if (!m_pfnGetPPSLength)				throw(_T("Don't find 'GetPPSLength' function"));

			m_pfnGetPPSNALUnit = (PROC_GetLPBYTEInArray)GET_PROC_ADDR(m_hInst, "GetPPSNALUnit");
			if (!m_pfnGetPPSNALUnit)			throw(_T("Don't find 'GetPPSNALUnit' function"));

			m_pfnGetBufferSizeDB = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetBufferSizeDB");
			if (!m_pfnGetBufferSizeDB)			throw(_T("Don't find 'GetBufferSizeDB' function"));

			m_pfnGetMaxBitrate = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetMaxBitrate");
			if (!m_pfnGetMaxBitrate)			throw(_T("Don't find 'GetMaxBitrate' function"));

			m_pfnGetAvgBitrate = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetAvgBitrate");
			if (!m_pfnGetAvgBitrate)			throw(_T("Don't find 'GetAvgBitrate' function"));

			m_pfnGetDecSpecificInfoData = (PROC_GetLPBYTEInEntry)GET_PROC_ADDR(m_hInst, "GetDecSpecificInfoData");
			if (!m_pfnGetDecSpecificInfoData)	throw(_T("Don't find 'GetDecSpecificInfoData' function"));

			m_pfnGetSTTSCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetSTTSCount");
			if (!m_pfnGetSTTSCount)				throw(_T("Don't find 'GetSTTSCount' function"));

			m_pfnGetSTTSSampleCount = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSTTSSampleCount");
			if (!m_pfnGetSTTSSampleCount)		throw(_T("Don't find 'GetSTTSSampleCount' function"));

			m_pfnGetSampleDelta = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSampleDelta");
			if (!m_pfnGetSampleDelta)			throw(_T("Don't find 'GetSampleDelta' function"));

			m_pfnGetExactSampleDelta = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetExactSampleDelta");
			if (!m_pfnGetExactSampleDelta)		throw(_T("Don't find 'GetExactSampleDelta' function"));

			m_pfnGetSTTSCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetSTTSCount");
			if (!m_pfnGetSTTSCount)				throw(_T("Don't find 'GetSTTSCount' function"));

			m_pfnGetSTTSSampleCount = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSTTSSampleCount");
			if (!m_pfnGetSTTSSampleCount)		throw(_T("Don't find 'GetSTTSSampleCount' function"));

			m_pfnGetSampleDelta = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSampleDelta");
			if (!m_pfnGetSampleDelta)			throw(_T("Don't find 'GetSampleDelta' function"));

			m_pfnGetExactSampleDelta = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetExactSampleDelta");
			if (!m_pfnGetExactSampleDelta)		throw(_T("Don't find 'GetExactSampleDelta' function"));

			m_pfnGetCTTSCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetCTTSCount");
			if (!m_pfnGetCTTSCount)				throw(_T("Don't find 'GetCTTSCount' function"));

			m_pfnGetCTTSSampleCount = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetCTTSSampleCount");
			if (!m_pfnGetCTTSSampleCount)		throw(_T("Don't find 'GetCTTSSampleCount' function"));

			m_pfnGetSampleOffset = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSampleOffset");
			if (!m_pfnGetSampleOffset)			throw(_T("Don't find 'GetSampleOffset' function"));

			m_pfnGetExactSampleOffset = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetExactSampleOffset");
			if (!m_pfnGetExactSampleOffset)		throw(_T("Don't find 'GetExactSampleOffset' function"));

			m_pfnGetSTSSCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetSTSSCount");
			if (!m_pfnGetCTTSCount)				throw(_T("Don't find 'GetCTTSCount' function"));

			m_pfnGetSampleNumber = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSampleNumber");
			if (!m_pfnGetSampleNumber)			throw(_T("Don't find 'GetSampleNumber' function"));

			m_pfnCheckSyncSample = (PROC_GetUINT8InEntry)GET_PROC_ADDR(m_hInst, "CheckSyncSample");
			if (!m_pfnCheckSyncSample)			throw(_T("Don't find 'CheckSyncSample' function"));

			m_pfnGetSTSCCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetSTSCCount");
			if (!m_pfnGetSTSCCount)				throw(_T("Don't find 'GetSTSCCount' function"));

			m_pfnGetFirstChunk = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetFirstChunk");
			if (!m_pfnGetFirstChunk)			throw(_T("Don't find 'GetFirstChunk' function"));

			m_pfnGetSamplesPerChunk = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSamplesPerChunk");
			if (!m_pfnGetSamplesPerChunk)		throw(_T("Don't find 'GetSamplesPerChunk' function"));

			m_pfnGetSampleDescIndex = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSampleDescIndex");
			if (!m_pfnGetSampleDescIndex)		throw(_T("Don't find 'GetSampleDescIndex' function"));

			m_pfnGetIndexUsingRealChunk = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetIndexUsingRealChunk");
			if (!m_pfnGetIndexUsingRealChunk)	throw(_T("Don't find 'GetIndexUsingRealChunk' function"));

			m_pfnCheckSample2Chunk = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "CheckSample2Chunk");
			if (!m_pfnCheckSample2Chunk)		throw(_T("Don't find 'CheckSample2Chunk' function"));

			m_pfnGetSampleSizeBoxType = (PROC_GetUINT8InTrack)GET_PROC_ADDR(m_hInst, "GetSampleSizeBoxType");
			if (!m_pfnGetSampleSizeBoxType)		throw(_T("Don't find 'GetSampleSizeBoxType' function"));

			m_pfnGetSampleSize = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetSampleSize");
			if (!m_pfnGetSampleSize)			throw(_T("Don't find 'GetSampleSize' function"));

			m_pfnGetFieldSize = (PROC_GetUINT8InTrack)GET_PROC_ADDR(m_hInst, "GetFieldSize");
			if (!m_pfnGetFieldSize)				throw(_T("Don't find 'GetFieldSize' function"));

			m_pfnGetSampleCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetSampleCount");
			if (!m_pfnGetSampleCount)			throw(_T("Don't find 'GetSampleCount' function"));

			m_pfnGetEntrySize = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetEntrySize");
			if (!m_pfnGetEntrySize)				throw(_T("Don't find 'GetEntrySize' function"));

			m_pfnGetChunkOffsetBoxType = (PROC_GetUINT8InTrack)GET_PROC_ADDR(m_hInst, "GetChunkOffsetBoxType");
			if (!m_pfnGetChunkOffsetBoxType)	throw(_T("Don't find 'GetChunkOffsetBoxType' function"));

			m_pfnGetSTCOCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetSTCOCount");
			if (!m_pfnGetSTCOCount)				throw(_T("Don't find 'GetSTCOCount' function"));

			m_pfnGetChunkOffset = (PROC_GetUINT64InEntry)GET_PROC_ADDR(m_hInst, "GetChunkOffset");
			if (!m_pfnGetChunkOffset)			throw(_T("Don't find 'GetChunkOffset' function"));

			m_pfnGetStereoCompositionType = (PROC_GetUINT8InTrack)GET_PROC_ADDR(m_hInst, "GetStereoCompositionType");
			if (!m_pfnGetStereoCompositionType)	throw(_T("Don't find 'GetStereoCompositionType' function"));

			m_pfnGetIsLeftFirst = (PROC_GetFlagInTrack)GET_PROC_ADDR(m_hInst, "GetIsLeftFirst");
			if (!m_pfnGetIsLeftFirst)			throw(_T("Don't find 'GetIsLeftFirst' function"));

			m_pfnGetStereoMonoChangeCount = (PROC_GetUINTInTrack)GET_PROC_ADDR(m_hInst, "GetStereoMonoChangeCount");
			if (!m_pfnGetStereoMonoChangeCount)	throw(_T("Don't find 'GetStereoMonoChangeCount' function"));

			m_pfnGetSVMISampleCount = (PROC_GetUINTInEntry)GET_PROC_ADDR(m_hInst, "GetSVMISampleCount");
			if (!m_pfnGetSVMISampleCount)		throw(_T("Don't find 'GetSVMISampleCount' function"));

			m_pfnGetStereoFlag = (PROC_GetFlagInEntry)GET_PROC_ADDR(m_hInst, "GetStereoFlag");
			if (!m_pfnGetStereoFlag)			throw(_T("Don't find 'GetStereoFlag' function"));
		}

		catch (TCHAR *szErrText)
		{
			m_hInst = NULL;

#ifdef _AFXDLL
			AfxMessageBox(szErrText);
#elif _CONSOLE
			cout << endl << szErrText << endl;
#else
			MessageBox(0, szErrText, _T("error"), 0);
#endif
		}

		bFirstTime			= 1;
		uStateOfStream		= 1;
		uStateOfAU			= 1;

		pPacket				= NULL;

		pFileStartPoint		= NULL;
		uTrackCount			= 0;

		uTrackIndex			= 0;
		uChunkIndex			= 0;
		uSampleEntryIndex	= 0;
		uSampleIndex		= 0;

		pOffset				= 0;

		uPayloadSize		= 0;
	}

	~CLibMP4Api()
	{
		if (m_hInst)
		{
			FreeLibrary(m_hInst);
			m_hInst = NULL;
		}

		bFirstTime			= 1;
		uStateOfStream		= 1;
		uStateOfAU			= 1;

		pPacket				= NULL;

		pFileStartPoint		= NULL;
		uTrackCount			= 0;

		uTrackIndex			= 0;
		uChunkIndex			= 0;
		uSampleEntryIndex	= 0;
		uSampleIndex		= 0;

		pOffset				= 0;
		uPayloadSize		= 0;

		auDescChangedChunk.clear();
		auOldSampleEntryIndex.clear();
		auCTS.clear();
		auDTS.clear();

		abySimpleDecoderConfigDescriptor.clear();

		auSampleCount.clear();

		auCurChunkIndex.clear();
		auSamplesInCurChunk.clear();

		auCurSampleSize.clear();
		auCurSampleOffset.clear();
		auCurSampleIndex.clear();
		afPassed.clear();
	}

	HMODULE	TestRightDLL()	{return m_hInst;}

	// wrapper functions
	INT8	OpenMP4File(void **theMovie, TCHAR *szFileName)
	{return m_pfnOpenMP4File(theMovie, szFileName);}

	INT8	OpenBitStream(void **theMovie, unsigned char *pBits, const UINT uSize)
	{return m_pfnOpenBitStream(theMovie, pBits, uSize);}

	void	CloseMP4Record()
	{return m_pfnCloseMP4Record();}

	void	RemoveMP4Record(void *pMP4)
	{return m_pfnRemoveMP4Record(pMP4);}

	void	*GetMP4Record()
	{return m_pfnGetMP4Record();}

	void	SetMP4Record(void *pMP4)
	{return m_pfnSetMP4Record(pMP4);}

	BYTE	*GetFileStartPoint()
	{return m_pfnGetFileStartPoint();}

	/************************************************************************/
	UINT	GetMajorBrand()
	{return m_pfnGetMajorBrand();}

	UINT	GetMinorVersion()
	{return m_pfnGetMinorVersion();}

	void	GetCompatibleBrands(vector<UINT> &aBrands)
	{return m_pfnGetCompatibleBrands(aBrands);}

	/************************************************************************/
	UINT64	GetMovieCreationTime()
	{return m_pfnGetMovieCreationTime();}

	UINT64	GetMovieModificationTime()
	{return m_pfnGetMovieModificationTime();}

	UINT	GetMovieTimeScale()
	{return m_pfnGetMovieTimeScale();}

	UINT64	GetMovieDuration()
	{return m_pfnGetMovieDuration();}

	float	GetRate()
	{return m_pfnGetRate();}

	float	GetMvoieVolume()
	{return m_pfnGetMovieVolume();}

	UINT	*GetMvoieMatrix()
	{return m_pfnGetMovieMatrix();}

	UINT	GetNextTrackID()
	{return m_pfnGetNextTrackID();}

	UINT8	HasIODS()
	{return m_pfnHasIODS();}

	UINT	GetTrackCount()
	{return m_pfnGetTrackCount();}

	UINT	TrackID2Index(const UINT uID)
	{return m_pfnTrackID2Index(uID);}

	UINT	GetObjectDescriptorID()
	{return m_pfnGetObjectDescriptorID();}

	UINT8	GetURLFlag()
	{return m_pfnGetURLFlag();}

	UINT8	GetInlineProfileLevelFlag()
	{return m_pfnGetInlineProfileLevelFlag();}

	UINT8	GetIODURLLength()
	{return m_pfnGetIODURLLength();}

	char	*GetIODURLString()
	{return m_pfnGetIODURLString();}

	UINT8	GetODProfileLevel()
	{return m_pfnGetODProfileLevel();}

	UINT8	GetSceneProfileLevel()
	{return m_pfnGetSceneProfileLevel();}

	UINT8	GetAudioProfileLevel()
	{return m_pfnGetAudioProfileLevel();}

	UINT8	GetVisualProfileLevel()
	{return m_pfnGetVisualProfileLevel();}

	UINT8	GetGraphicsProfileLevel()
	{return m_pfnGetGraphicsProfileLevel();}

	UINT8	GetESDescSize()
	{return m_pfnGetESDescSize();}

	/************************************************************************/
	UINT64	GetTrackCreationTime(const UINT uTrackIndex)
	{return m_pfnGetTrackCreationTime(uTrackIndex);}

	UINT64	GetTrackModificationTime(const UINT uTrackIndex)
	{return m_pfnGetTrackModificationTime(uTrackIndex);}

	UINT	GetTrackID(const UINT uTrackIndex)
	{return m_pfnGetTrackID(uTrackIndex);}

	UINT64	GetTrackDuration(const UINT uTrackIndex)
	{return m_pfnGetTrackDuration(uTrackIndex);}

	int		GetLayer(const UINT uTrackIndex)
	{return m_pfnGetLayer(uTrackIndex);}

	UINT	GetAlternateGroup(const UINT uTrackIndex)
	{return m_pfnGetAlternateGroup(uTrackIndex);}

	float	GetTrackVolume(const UINT uTrackIndex)
	{return m_pfnGetTrackVolume(uTrackIndex);}

	UINT	*GetTrackMatrix(const UINT uTrackIndex)
	{return m_pfnGetTrackMatrix(uTrackIndex);}

	UINT	GetWidth(const UINT uTrackIndex)
	{return m_pfnGetWidth(uTrackIndex);}

	UINT	GetHeight(const UINT uTrackIndex)
	{return m_pfnGetHeight(uTrackIndex);}

	UINT8	HasTREF(const UINT uTrackIndex)
	{return m_pfnHasTREF(uTrackIndex);}

	UINT64	GetMediaCreationTime(const UINT uTrackIndex)
	{return m_pfnGetMediaCreationTime(uTrackIndex);}

	UINT64	GetMediaModificationTime(const UINT uTrackIndex)
	{return m_pfnGetMediaModificationTime(uTrackIndex);}

	UINT	GetMediaTimeScale(const UINT uTrackIndex)
	{return m_pfnGetMediaTimeScale(uTrackIndex);}

	UINT64	GetMediaDuration(const UINT uTrackIndex)
	{return m_pfnGetMediaDuration(uTrackIndex);}

	UINT	GetLanguage(const UINT uTrackIndex)
	{return m_pfnGetLanguage(uTrackIndex);}

	UINT	GetHandlerType(const UINT uTrackIndex)
	{return m_pfnGetHandlerType(uTrackIndex);}

	char	*GetHandlerName(const UINT uTrackIndex)
	{return m_pfnGetHandlerName(uTrackIndex);}

	UINT	GetMediaHeaderType(const UINT uTrackIndex)
	{return m_pfnGetMediaHeaderType(uTrackIndex);}

	UINT	GetMP4GraphicsMode(const UINT uTrackIndex)
	{return m_pfnGetMP4GraphicsMode(uTrackIndex);}

	UINT	*GetOpColor(const UINT uTrackIndex)
	{return m_pfnGetOpColor(uTrackIndex);}

	float	GetBalance(const UINT uTrackIndex)
	{return m_pfnGetBalance(uTrackIndex);}

	UINT	GetMaxPDUSize(const UINT uTrackIndex)
	{return m_pfnGetMaxPDUSize(uTrackIndex);}

	UINT	GetAvgPDUSize(const UINT uTrackIndex)
	{return m_pfnGetAvgPDUSize(uTrackIndex);}

	UINT	GetMaxHintBitrate(const UINT uTrackIndex)
	{return m_pfnGetMaxHintBitrate(uTrackIndex);}

	UINT	GetAvgHintBitrate(const UINT uTrackIndex)
	{return m_pfnGetAvgHintBitrate(uTrackIndex);}

	UINT	GetDREFCount(const UINT uTrackIndex)
	{return m_pfnGetDREFCount(uTrackIndex);}

	UINT	GetDREFType(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetDREFType(uTrackIndex, uEntryIndex);}

	char	*GetDataName(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetDataName(uTrackIndex, uEntryIndex);}

	char	*GetLocation(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetLocation(uTrackIndex, uEntryIndex);}

	/************************************************************************/
	UINT8	HasCTTS(const UINT uTrackIndex)
	{return m_pfnHasCTTS(uTrackIndex);}

	UINT8	HasSTSS(const UINT uTrackIndex)
	{return m_pfnHasSTSS(uTrackIndex);}

	UINT8	HasSVMI(const UINT uTrackIndex)
	{return m_pfnHasSVMI(uTrackIndex);}

	UINT	GetSampleDescCount(const UINT uTrackIndex)
	{return m_pfnGetSampleDescCount(uTrackIndex);}

	UINT	GetSampleDescType(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSampleDescType(uTrackIndex, uEntryIndex);}

	BYTE	*GetDecoderConfigOffset(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetDecoderConfigOffset(uTrackIndex, uEntryIndex);}

	UINT	GetDecoderConfigSize(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetDecoderConfigSize(uTrackIndex, uEntryIndex);}

	UINT	GetDataReferenceIndex(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetDataReferenceIndex(uTrackIndex, uEntryIndex);}

	UINT8	HasBTRT(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnHasBTRT(uTrackIndex, uEntryIndex);}

	UINT8	HasM4DS(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnHasM4DS(uTrackIndex, uEntryIndex);}

	UINT	GetVisualWidth(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetVisualWidth(uTrackIndex, uEntryIndex);}

	UINT	GetVisualHeight(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetVisualHeight(uTrackIndex, uEntryIndex);}

	UINT	GetHorizResolution(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetHorizResolution(uTrackIndex, uEntryIndex);}

	UINT	GetVertResolution(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetVertResolution(uTrackIndex, uEntryIndex);}

	UINT	GetFrameCount(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetFrameCount(uTrackIndex, uEntryIndex);}

	char	*GetCompressorName(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetCompressorName(uTrackIndex, uEntryIndex);}

	UINT	GetDepth(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetDepth(uTrackIndex, uEntryIndex);}

	UINT	GetChannelCount(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetChannelCount(uTrackIndex, uEntryIndex);}

	UINT	GetAudioSampleSize(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetAudioSampleSize(uTrackIndex, uEntryIndex);}

	UINT	GetSampleRate(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSampleRate(uTrackIndex, uEntryIndex);}

	BYTE	*GetData(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetData(uTrackIndex, uEntryIndex);}

	UINT	GetESID(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetESID(uTrackIndex, uEntryIndex);}

	UINT8	GetStreamDependenceFlag(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetStreamDependenceFlag(uTrackIndex, uEntryIndex);}

	UINT8	GetESURLFlag(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetESURLFlag(uTrackIndex, uEntryIndex);}

	UINT8	GetOCRStreamFlag(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetOCRStreamFlag(uTrackIndex, uEntryIndex);}

	UINT8	GetStreamPriority(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetStreamPriority(uTrackIndex, uEntryIndex);}

	UINT	GetDependsOnESID(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetDependsOnESID(uTrackIndex, uEntryIndex);}

	UINT8	GetESURLLength(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetESURLLength(uTrackIndex, uEntryIndex);}

	char	*GetESURLString(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetESURLString(uTrackIndex, uEntryIndex);}

	UINT	GetOCRESID(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetOCRESID(uTrackIndex, uEntryIndex);}

	UINT8	GetESObjectType(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetESObjectType(uTrackIndex, uEntryIndex);}

	UINT8	GetStreamType(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetStreamType(uTrackIndex, uEntryIndex);}

	UINT8	GetUpStream(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetUpStream(uTrackIndex, uEntryIndex);}

	UINT8	GetConfigurationVersion(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetConfigurationVersion(uTrackIndex, uEntryIndex);}

	UINT8	GetAVCProfileIndication(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetAVCProfileIndication(uTrackIndex, uEntryIndex);}

	UINT8	GetProfileCompatibility(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetProfileCompatibility(uTrackIndex, uEntryIndex);}

	UINT8	GetAVCLevelIndication(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetAVCLevelIndication(uTrackIndex, uEntryIndex);}

	UINT8	GetLength(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetLength(uTrackIndex, uEntryIndex);}

	UINT8	GetNumOfSPS(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetNumOfSPS(uTrackIndex, uEntryIndex);}

	UINT	GetSPSLength(const UINT uTrackIndex, const UINT uEntryIndex, const UINT8 i)
	{return m_pfnGetSPSLength(uTrackIndex, uEntryIndex, i);}

	BYTE	*GetSPSNALUnit(const UINT uTrackIndex, const UINT uEntryIndex, const UINT8 i)
	{return m_pfnGetSPSNALUnit(uTrackIndex, uEntryIndex, i);}

	UINT8	GetNumOfPPS(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetNumOfPPS(uTrackIndex, uEntryIndex);}

	UINT	GetPPSLength(const UINT uTrackIndex, const UINT uEntryIndex, const UINT8 i)
	{return m_pfnGetPPSLength(uTrackIndex, uEntryIndex, i);}

	BYTE	*GetPPSNALUnit(const UINT uTrackIndex, const UINT uEntryIndex, const UINT8 i)
	{return m_pfnGetPPSNALUnit(uTrackIndex, uEntryIndex, i);}

	UINT	GetBufferSizeDB(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetBufferSizeDB(uTrackIndex, uEntryIndex);}

	UINT	GetMaxBitrate(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetMaxBitrate(uTrackIndex, uEntryIndex);}

	UINT	GetAvgBitrate(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetAvgBitrate(uTrackIndex, uEntryIndex);}

	BYTE	*GetDecSpecificInfoData(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetDecSpecificInfoData(uTrackIndex, uEntryIndex);}

	UINT	GetSTTSCount(const UINT uTrackIndex)
	{return m_pfnGetSTTSCount(uTrackIndex);}

	UINT	GetSTTSSampleCount(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSTTSSampleCount(uTrackIndex, uEntryIndex);}

	UINT	GetSampleDelta(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSampleDelta(uTrackIndex, uEntryIndex);}

	UINT	GetExactSampleDelta(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetExactSampleDelta(uTrackIndex, uEntryIndex);}

	UINT	GetCTTSCount(const UINT uTrackIndex)
	{return m_pfnGetCTTSCount(uTrackIndex);}

	UINT	GetCTTSSampleCount(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetCTTSSampleCount(uTrackIndex, uEntryIndex);}

	UINT	GetSampleOffset(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSampleOffset(uTrackIndex, uEntryIndex);}

	UINT	GetExactSampleOffset(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetExactSampleOffset(uTrackIndex, uEntryIndex);}

	UINT	GetSTSSCount(const UINT uTrackIndex)
	{return m_pfnGetSTSSCount(uTrackIndex);}

	UINT	GetSampleNumber(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSampleNumber(uTrackIndex, uEntryIndex);}

	UINT8	CheckSyncSample(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnCheckSyncSample(uTrackIndex, uEntryIndex);}

	UINT	GetSTSCCount(const UINT uTrackIndex)
	{return m_pfnGetSTSCCount(uTrackIndex);}

	UINT	GetFirstChunk(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetFirstChunk(uTrackIndex, uEntryIndex);}

	UINT	GetSamplesPerChunk(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSamplesPerChunk(uTrackIndex, uEntryIndex);}

	UINT	GetSampleDescIndex(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSampleDescIndex(uTrackIndex, uEntryIndex);}

	UINT	GetIndexUsingRealChunk(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetIndexUsingRealChunk(uTrackIndex, uEntryIndex);}

	UINT	CheckSample2Chunk(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnCheckSample2Chunk(uTrackIndex, uEntryIndex);}

	UINT8	GetSampleSizeBoxType(const UINT uTrackIndex)
	{return m_pfnGetSampleSizeBoxType(uTrackIndex);}

	UINT	GetSampleSize(const UINT uTrackIndex)
	{return m_pfnGetSampleSize(uTrackIndex);}

	UINT8	GetFieldSize(const UINT uTrackIndex)
	{return m_pfnGetFieldSize(uTrackIndex);}

	UINT	GetSampleCount(const UINT uTrackIndex)
	{return m_pfnGetSampleCount(uTrackIndex);}

	UINT	GetEntrySize(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetEntrySize(uTrackIndex, uEntryIndex);}

	UINT8	GetChunkOffsetBoxType(const UINT uTrackIndex)
	{return m_pfnGetChunkOffsetBoxType(uTrackIndex);}

	UINT	GetSTCOCount(const UINT uTrackIndex)
	{return m_pfnGetSTCOCount(uTrackIndex);}

	UINT64	GetChunkOffset(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetChunkOffset(uTrackIndex, uEntryIndex);}

	UINT8	GetStereoCompositionType(const UINT uTrackIndex)
	{return m_pfnGetStereoCompositionType(uTrackIndex);}

	UINT8	GetIsLeftFirst(const UINT uTrackIndex)
	{return m_pfnGetIsLeftFirst(uTrackIndex);}

	UINT	GetStereoMonoChangeCount(const UINT uTrackIndex)
	{return m_pfnGetStereoMonoChangeCount(uTrackIndex);}

	UINT	GetSVMISampleCount(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetSVMISampleCount(uTrackIndex, uEntryIndex);}

	UINT8	GetStereoFlag(const UINT uTrackIndex, const UINT uEntryIndex)
	{return m_pfnGetStereoFlag(uTrackIndex, uEntryIndex);}
};

#endif