/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#ifndef _DEC_BITREADER_H_
#define _DEC_BITREADER_H_

#include "DecTools.h"


class CBitReader
{
protected:
	char		*m_szStreambytes;
	int			m_nStartByte, m_nCurByte, m_nCurBit;

public:
	CBitReader(char *szFileData);
	CBitReader(char *szFileData, int uBitReaderPtr);

public:
	int			m_nCurrentBit;

public:
	bool*		GetBitsfromByte(char szByte);

	bool		GetBit();
	int			GetBits(int uLength);
	int			GetByte();
	vector<int>	GetByteArray(int uLength);
	int			GetVlcInt(int uLength);
	tstring		GetString(int uLength, ofstream &xmlfile);
	tstring		GetStringList(CBitReader *pBR);
	tstring		GetStringList(CBitReader *pBR, ofstream &xmlfile);

	void		IncCurrentBit(int n)	{ m_nCurrentBit += n; }

	void		flush(CBitReader *pBR);
};


#endif