/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#ifndef _DEC_MANAGER_H_
#define _DEC_MANAGER_H_

#include "DecTools.h"

#include "U.h"


class CManager
{
public:
	CManager();
	~CManager();

public:
	vector<int>		m_anColors;
	int				m_nNbColorsAlreadySaved;
	vector<tstring>	m_astrFonts;
	int				m_nNbFontsAlreadySaved;
	vector<int>		m_anNameSpaces;
	int				m_nNbNameSpacesAlreadySaved;
	vector<int>		m_anPrivateTags;
	int				m_nNbTagsAlreadySaved;
//	bool			m_bDebug;

public:
	int				colorsAlreadySaved()		{ return m_nNbColorsAlreadySaved; }
	int				fontsAlreadySaved()			{ return m_nNbFontsAlreadySaved; }
	int				nameSpacesAlreadySaved()	{ return m_nNbNameSpacesAlreadySaved; }
	int				tagsAlreadySaved()			{ return m_nNbTagsAlreadySaved; }

	int				nbOfColors()	{ return m_anColors.size(); }
	int				addColor(int c);
	int				getColor(int i, ofstream &xmlfile);

	int				registerFont(tstring s);
	int				nbOfFonts()		{ return m_astrFonts.size(); }
	tstring			getFont(int i, ofstream &xmlfile);

//	int				nbOfAttrs(int i)	{ return ((Manager.Tag)privateTags.elementAt(i)).attrNames.size(); }
};


class CIDManager
{
public:
	CIDManager();
	~CIDManager();

public:
	vector<int>		m_anElementIDs;
	bool			m_bElementIDHole;
	vector<tstring> m_astrStreamDefs;
	bool			m_bStreamHole;
	vector<CURI*>	m_apPaintURI;

public:
	void			setStreamID(tstring s, int j);
	int				registerPaintURI(CURI *u);
};


class CTag
{
public:
	CTag();
	~CTag();

public:
	CQName			*m_pName;
	vector<tstring>	m_astrAttrNames;
};


#endif