/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#include "X.h"


// CQName
CQName::CQName()
{
	m_strName	= _T("");
}

// CPrivAttr
CPrivAttr::CPrivAttr()
{
	CQName::CQName();

	m_strValue	= _T("");
}

// CX
CX::CX()
{
	m_strClasse						=_T("");
	m_strBase						=_T("");
	m_strLang						=_T("");
	m_bExternalResourcesRequired	= false;
}

// CXpropElem
CXpropElem::CXpropElem()
{
	CX::CX();
}

CXpropElem::~CXpropElem()
{
	m_anStroke_dasharray.clear();
}

void CXpropElem::setDisplay(int nDisplay, ofstream &xmlfile)
{
	switch (nDisplay)
	{
	case 0:	xmlfile << "block'";				break;
	case 1:	xmlfile << "compact'";				break;
	case 2:	xmlfile << "inherit'";				break;
	case 3:	xmlfile << "inline'";				break;
	case 4:	xmlfile << "inline-table'";			break;
	case 5:	xmlfile << "list-item'";			break;
	case 6:	xmlfile << "marker'";				break;
	case 7:	xmlfile << "none'";					break;
	case 8:	xmlfile << "run-in'";				break;
	case 9:	xmlfile << "table";					break;
	case 10:xmlfile << "table-caption'";		break;
	case 11:xmlfile << "table-cell'";			break;
	case 12:xmlfile << "table-column'";			break;
	case 13:xmlfile << "table-column-group'";	break;
	case 14:xmlfile << "table-footer-group'";	break;
	case 15:xmlfile << "table-header-group'";	break;
	case 16:xmlfile << "table-row'";			break;
	case 17:xmlfile << "table-row-group'";		break;
	}
	 m_nDisplay = nDisplay;
}

void CXpropElem::setVisibility(int nVisibility, ofstream &xmlfile)
{
	switch (nVisibility)
	{
	case 1:	xmlfile << "inherit'";	break;
	case 0:	xmlfile << "hidden'";	break;
	case 2:	xmlfile << "visible'";	break;
	}
	m_nVisibility = nVisibility;
}

void CXpropElem::setVector_effectType(int nVector_effect, ofstream &xmlfile)
{
	switch (nVector_effect)
	{
	case 1:	xmlfile << "inherit'";				break;
	case 0:	xmlfile << "none'";					break;
	case 2:	xmlfile << "non-scaling-stroke'";	break;
	}
	m_nVector_effect = nVector_effect;
}

// CXset
CXset::CXset()
{
	CX::CX();
}

CXset::~CXset()
{

}