/*
// This software was originally developed by ETRI and Kyunghee University, in the course
// of development of the ISO/IEC 14496-20 (Lightweight Application Scene Representation 
// -LASeR- and Simple Aggregation Format -SAF-) AMD3: Presentation and Modification of
// Structured Information standard for reference purposes and its performance may not 
// have been optimized.
//
// This software module is an implementation of one or more tools as specified by the
// ISO/IEC 14496-20 AMD3: PMSI standard.
//
// ISO/IEC gives users free license to this software module or modifications thereof
// for use in products claiming conformance to audiovisual and image-coding related
// ITU Recommendations and/or ISO/IEC International Standards.
// 
// ISO/IEC gives users the same free license to this software module or modifications
// thereof for research purposes and further ISO/IEC standardisation.
// Those intending to use this software module in products are advised that its use may
// infringe existing patents. 
// 
// The original developer of this software module and his/her company, the 
// subsequent editors and their companies, and ISO/IEC have no liability for use of
// this software module or modifications thereof in an implementation.
//
// Copyright is not released for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
// The organizations named above retain full rights to use the code for their own
// purpose, assign or donate the code to a third party and inhibit third parties 
// from using the code for products that do not conform to audiovisual and 
// image-coding related ITU Recommendations and/or ISO/IEC International Standards.
//
// This copyright notice must be included in all copies or derivative works.
// 
// Copyright (c) ISO/IEC 2010
//
// This notice must be included in all copies or derivative works.
*/
#include "bin2xml.h"
#include "PreDecoder.h"


CBIN2XMLManager::CBIN2XMLManager()
{

}

CBIN2XMLManager::~CBIN2XMLManager()
{

}

extern "C" _declspec(dllexport)
void __stdcall OpenBinFile(const TCHAR *szInputFileName)
{
	ifstream	file(szInputFileName, ios::in|ios::binary);
	ofstream	xmlfile;
	int			uFileSize		= 0;
	char		*szFileData		= NULL;

	// move to file's end
	file.seekg(-1, ios_base::end);

	// get file size
	// 2 : for null
	uFileSize = (int)(file.tellg()) + 2;

	szFileData = new char[uFileSize];

	memset(szFileData, 0, uFileSize);

	// move to file's start point to read correctly
	file.seekg(0, ios_base::beg);
	file.read(szFileData, uFileSize);
	file.close();

	CBIN2XMLManager *pB2XMgr	= new CBIN2XMLManager();
	CPreDecoder		*pPreDecode = new CPreDecoder();

	tstring strFileName = szInputFileName;
	strFileName.replace(strFileName.size() - 4, strFileName.size(), _T("_d.xml"));
	TCHAR szTemp[300];
	wsprintf(szTemp, _T("%s"), strFileName.c_str());

	xmlfile.open(szTemp);

	CScene		*pScene	= new CScene();
	CSDLClasses	*sdl	= new CSDLClasses();
	CBitReader	*pBR	= new CBitReader(szFileData);

	pB2XMgr->PreXMLWriter(xmlfile);
	pPreDecode->PreDecode(pScene, sdl, pBR, szFileData, xmlfile);

	xmlfile.close();

	delete pB2XMgr;
}

void CBIN2XMLManager::PreXMLWriter(ofstream &xmlfile)
{
	xmlfile << "<?xml version='1.0' encoding='UTF-8'?>";
	xmlfile << "\n<saf:SAFSession xmlns:saf='urn:mpeg:mpeg4:SAF:2005' xmlns:lsr='urn:mpeg:mpeg4:LASeR:2005' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' xmlns:smil='http://www.w3.org/2005/SMIL21' xmlns:ev='http://www.w3.org/2001/xml-events'>";
}